// 001 u_c_session_list
// 04 mar 00

(*$r+*)

unit u_c_person_list;
  interface
    uses Classes, Generics.Collections;

    type (*$m+*)
         c_person= // one "person"
             Class
               // -- m_name:
               private
                 FFirstName: string;
                 FAge: integer;
                 FMarried: boolean;
                 procedure SetMarried(const Value: boolean);
                 procedure SetFirstName(const Value: string);
                 procedure SetAge(const Value: integer);
               public
                 constructor create_person(p_name: string);
                 constructor create_full(p_name: String; p_age: Integer);
                 function f_c_self: c_person;
                 function f_display_person: String;
               published
                 property FirstName: string read FFirstName write SetFirstName;
                 property Age: integer read FAge write SetAge;
                 property Married: boolean read FMarried write SetMarried;
             end; // c_person
         (*$m-*)

         t_cp_person_list= tObjectList<c_person>;

    function f_c_create_and_fill_person(p_firstname: String; p_age: Integer; p_married: Boolean): c_person;
    function f_c_create_and_fill_person_list: t_cp_person_list;
    function f_load_person_list(p_c_person_list: t_cp_person_list; p_path, p_file_name: String): Integer;


  implementation
    uses Math, SysUtils
        ;

    // -- c_person

    Constructor c_person.create_person(p_name: String);
      begin
        Inherited create;
        FirstName:= p_name;
      end; // create_person

    Constructor c_person.create_full(p_name: String; p_age: Integer);
      begin
        Inherited create;
        FirstName:= p_name;
        Age:= p_age;
      end;

    function c_person.f_c_self: c_person;
      begin
        Result:= Self;
      end; // f_c_self

    function c_person.f_display_person: String;
      begin
        Result:= Format('%-21s %2d ', [FirstName, Age]); // , f_display_TF(Married)
      end; // f_display_person

    procedure c_person.SetMarried(const Value: boolean);
      begin
        FMarried:= Value;
      end; // SetMarried

    procedure c_person.SetFirstName(const Value: string);
      begin
        FFirstName:= Value;
      end; // SetFirstName

    procedure c_person.SetAge(const Value: integer);
      begin
        FAge:= Value;
      end; // SetAge

    // -- t_p_person_list

    function f_c_create_and_fill_person(p_firstname: String; p_age: Integer; p_married: Boolean): c_person;
      begin
        Result:= c_person.create_person(p_firstname);
        Result.Age:= p_age;
        Result.Married:= p_married;
      end; // f_c_create_and_fill_person

    function f_c_create_and_fill_person_list: t_cp_person_list;

      procedure add_person(p_firstname: String; p_age: Integer; p_married: Boolean);
        begin
          Result.Add(f_c_create_and_fill_person(p_firstname, p_age, p_married));
        end; // add_person

      begin // f_c_create_and_fill_person_list
        Result:= tObjectList<c_person>.Create;

        add_person('SMITH', 11, False);
        add_person('MILLER', 22, True);
        add_person('BROWN', 33, True);
      end; // f_c_create_and_fill_person_list

    function f_load_person_list(p_c_person_list: t_cp_person_list; p_path, p_file_name: String): Integer;
      begin
        Result:= -1;
      end; // f_load_person_list


    begin // u_c_person_list
    end. // u_c_person_list
